<script setup lang="ts">
    import { computed } from "vue";
    import { VTextField } from "vuetify/components";

    const props = defineProps(["modelValue"]);
    const emit = defineEmits(["update:modelValue"]);

    const localValue = computed({
        get: () => inputToPickerFormat(props.modelValue),
        set: (value: any): void => {
            emit("update:modelValue", pickerToOutputFormat(value));
        },
    });

    function inputToPickerFormat(input: number | null | undefined) {
        if (input == null || input == undefined) {
            return null;
        }

        const workDate = new Date(input);

        // Get the year, month, day, hour, and minute from the current date
        const year = workDate.getFullYear();
        const month = (workDate.getMonth() + 1).toString().padStart(2, "0"); // !! zero indexed month
        const day = workDate.getDate().toString().padStart(2, "0");
        const hour = workDate.getHours().toString().padStart(2, "0");
        const minute = workDate.getMinutes().toString().padStart(2, "0");

        // Construct the new format
        const output = `${year}-${month}-${day}T${hour}:${minute}:00`;

        return output;
    }
    function pickerToOutputFormat(input: string | null | undefined): number {
        if (input == null || input == undefined) {
            return 0;
        }
        const [datePart, timePart] = input.split("T");
        const [year, month, day] = datePart.split("-");
        const [hour, minute] = timePart.split(":");

        return new Date(parseInt(year), parseInt(month) - 1, parseInt(day), parseInt(hour), parseInt(minute)).getTime(); // !! zero indexed month
    }
</script>

<template>
    <v-text-field type="datetime-local" v-model="localValue" />
</template>
